##############################################################################
##
#W  mwohom.tst                    Gpd Package                    Chris Wensley
##
#H  @(#)$Id: mwo.tst,v 1.05 2008/11/21 gap Exp $
##
#Y  Copyright (C) 1999,2001 University of St. Andrews, North Haugh,
#Y                          St. Andrews, Fife KY16 9SS, Scotland
##

gap> START_TEST( "Testing examples in Chapter 3 of the Gpd manual" );

gap> gpd_infolevel_saved := InfoLevel( InfoGpd );; 
gap> SetInfoLevel( InfoGpd, 0 );;

gap> tup1 := [ Tuple([m1,m2]), Tuple([m2,m1]), Tuple([m3,m4]), Tuple([m4,m3]) ];; 
gap> f1 := GeneralMappingByElements( m, m, tup1 ); 
<general mapping: m -> m >
gap> IsMagmaHomomorphism( f1 ); 
true
gap> tup2 := [ Tuple([m1,m1]), Tuple([m2,m1]), Tuple([m3,m1]), Tuple([m4,m1]) ];; 
gap> f2 := GeneralMappingByElements( m, m, tup2 );; 
gap> IsMagmaHomomorphism( f2 );
true 
gap> map1 := MagmaWithObjectsHomomorphism( M78, M78, f1, [-8,-7] );; 
gap> Display( map1 );
Mapping to single piece magma:
[ magma with objects :-
    magma = m
  objects = [ -8, -7 ]
 ] -> [ magma with objects :-
    magma = m
  objects = [ -8, -7 ]
 ]
magma mapping: <mapping: m -> m >
   object map: [ -8, -7 ] -> [ -8, -7 ]

gap> i78 := ImageElm( map1, a78 );
[m1 : -7 -> -8]
gap> map2 := MagmaHomomorphismFromSinglePiece( M78, M78, f2, [-7,-8] );; 
gap> Display( map2 ); 
[ magma with objects :-
    magma = m
  objects = [ -8, -7 ]
 ] -> [ magma with objects :-
    magma = m
  objects = [ -8, -7 ]
 ]
magma mapping: <mapping: m -> m >
   object map: [ -8, -7 ] -> [ -7, -8 ]

gap> ImageElm( map2, i78 );
[m1 : -8 -> -7]

gap> prod := map1*map2;
magma with objects mapping : magma with objects :-
    magma = m
  objects = [ -8, -7 ]
 -> magma with objects :-
    magma = m
  objects = [ -8, -7 ]

gap> ImageElm( prod, a78 );
[m1 : -8 -> -7]

gap> SetInfoLevel( InfoGpd, gpd_infolevel_saved );;  

gap> STOP_TEST( "mwohom.tst", 10000 );

##############################################################################
##
#E  mwohom.tst . . . . . . . . . . . . . . . . . . . . . . . . . . . ends here
